diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index ef5b34a312..af4d1dcc2f 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -1539,7 +1539,7 @@ RangeVarCallbackForDropRelation(const RangeVar *rel, Oid relOid, Oid oldRelOid,
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relOid));
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped, so nothing to do */
-	classform = (Form_pg_class) GETSTRUCT(tuple);
+	classform = GETSTRUCT(pg_class, tuple);
 	is_partition = classform->relispartition;
 
 	/* Pass back some data to save lookups in RemoveRelations */
@@ -1591,7 +1591,7 @@ RangeVarCallbackForDropRelation(const RangeVar *rel, Oid relOid, Oid oldRelOid,
 			return;
 		}
 
-		indexform = (Form_pg_index) GETSTRUCT(locTuple);
+		indexform = GETSTRUCT(pg_index, locTuple);
 		indisvalid = indexform->indisvalid;
 		ReleaseSysCache(locTuple);
 
@@ -3244,7 +3244,7 @@ SetRelationHasSubclass(Oid relationId, bool relhassubclass)
 	tuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relationId));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relationId);
-	classtuple = (Form_pg_class) GETSTRUCT(tuple);
+	classtuple = GETSTRUCT(pg_class, tuple);
 
 	if (classtuple->relhassubclass != relhassubclass)
 	{
@@ -3346,7 +3346,7 @@ SetRelationTableSpace(Relation rel,
 	tuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(reloid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", reloid);
-	rd_rel = (Form_pg_class) GETSTRUCT(tuple);
+	rd_rel = GETSTRUCT(pg_class, tuple);
 
 	/* Update the pg_class row. */
 	rd_rel->reltablespace = (newTableSpaceId == MyDatabaseTableSpace) ?
@@ -3518,7 +3518,7 @@ renameatt_internal(Oid myrelid,
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" does not exist",
 						oldattname)));
-	attform = (Form_pg_attribute) GETSTRUCT(atttup);
+	attform = GETSTRUCT(pg_attribute, atttup);
 
 	attnum = attform->attnum;
 	if (attnum <= 0)
@@ -3574,7 +3574,7 @@ RangeVarCallbackForRenameAttribute(const RangeVar *rv, Oid relid, Oid oldrelid,
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped */
-	form = (Form_pg_class) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_class, tuple);
 	renameatt_check(relid, form, false);
 	ReleaseSysCache(tuple);
 }
@@ -3660,7 +3660,7 @@ rename_constraint_internal(Oid myrelid,
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for constraint %u",
 			 constraintOid);
-	con = (Form_pg_constraint) GETSTRUCT(tuple);
+	con = GETSTRUCT(pg_constraint, tuple);
 
 	if (myrelid && con->contype == CONSTRAINT_CHECK && !con->connoinherit)
 	{
@@ -3872,7 +3872,7 @@ RenameRelationInternal(Oid myrelid, const char *newrelname, bool is_internal, bo
 	reltup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(myrelid));
 	if (!HeapTupleIsValid(reltup))	/* shouldn't happen */
 		elog(ERROR, "cache lookup failed for relation %u", myrelid);
-	relform = (Form_pg_class) GETSTRUCT(reltup);
+	relform = GETSTRUCT(pg_class, reltup);
 
 	if (get_relname_relid(newrelname, namespaceId) != InvalidOid)
 		ereport(ERROR,
@@ -3947,7 +3947,7 @@ ResetRelRewrite(Oid myrelid)
 	reltup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(myrelid));
 	if (!HeapTupleIsValid(reltup))	/* shouldn't happen */
 		elog(ERROR, "cache lookup failed for relation %u", myrelid);
-	relform = (Form_pg_class) GETSTRUCT(reltup);
+	relform = GETSTRUCT(pg_class, reltup);
 
 	/*
 	 * Update pg_class tuple.
@@ -6443,7 +6443,7 @@ find_composite_type_dependencies(Oid typeOid, Relation origRelation,
 
 	while (HeapTupleIsValid(depTup = systable_getnext(depScan)))
 	{
-		Form_pg_depend pg_depend = (Form_pg_depend) GETSTRUCT(depTup);
+		Form_pg_depend pg_depend = GETSTRUCT(pg_depend, depTup);
 		Relation	rel;
 		Form_pg_attribute att;
 
@@ -6549,7 +6549,7 @@ find_typed_table_dependencies(Oid typeOid, const char *typeName, DropBehavior be
 
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class classform = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class classform = GETSTRUCT(pg_class, tuple);
 
 		if (behavior == DROP_RESTRICT)
 			ereport(ERROR,
@@ -6581,7 +6581,7 @@ find_typed_table_dependencies(Oid typeOid, const char *typeName, DropBehavior be
 void
 check_of_type(HeapTuple typetuple)
 {
-	Form_pg_type typ = (Form_pg_type) GETSTRUCT(typetuple);
+	Form_pg_type typ = GETSTRUCT(pg_type, typetuple);
 	bool		typeOk = false;
 
 	if (typ->typtype == TYPTYPE_COMPOSITE)
@@ -6700,7 +6700,7 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 		tuple = SearchSysCacheCopyAttName(myrelid, colDef->colname);
 		if (HeapTupleIsValid(tuple))
 		{
-			Form_pg_attribute childatt = (Form_pg_attribute) GETSTRUCT(tuple);
+			Form_pg_attribute childatt = GETSTRUCT(pg_attribute, tuple);
 			Oid			ctypeId;
 			int32		ctypmod;
 			Oid			ccollid;
@@ -6781,10 +6781,10 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	reltup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(myrelid));
 	if (!HeapTupleIsValid(reltup))
 		elog(ERROR, "cache lookup failed for relation %u", myrelid);
-	relkind = ((Form_pg_class) GETSTRUCT(reltup))->relkind;
+	relkind = (GETSTRUCT(pg_class, reltup))->relkind;
 
 	/* Determine the new attribute's number */
-	newattnum = ((Form_pg_class) GETSTRUCT(reltup))->relnatts + 1;
+	newattnum = (GETSTRUCT(pg_class, reltup))->relnatts + 1;
 	if (newattnum > MaxHeapAttributeNumber)
 		ereport(ERROR,
 				(errcode(ERRCODE_TOO_MANY_COLUMNS),
@@ -6792,7 +6792,7 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 						MaxHeapAttributeNumber)));
 
 	typeTuple = typenameType(NULL, colDef->typeName, &typmod);
-	tform = (Form_pg_type) GETSTRUCT(typeTuple);
+	tform = GETSTRUCT(pg_type, typeTuple);
 	typeOid = tform->oid;
 
 	aclresult = pg_type_aclcheck(typeOid, GetUserId(), ACL_USAGE);
@@ -6844,7 +6844,7 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	/*
 	 * Update pg_class tuple as appropriate
 	 */
-	((Form_pg_class) GETSTRUCT(reltup))->relnatts = newattnum;
+	(GETSTRUCT(pg_class, reltup))->relnatts = newattnum;
 
 	CatalogTupleUpdate(pgclass, &reltup->t_self, reltup);
 
@@ -7077,7 +7077,7 @@ check_for_column_name_collision(Relation rel, const char *colname,
 	if (!HeapTupleIsValid(attTuple))
 		return true;
 
-	attnum = ((Form_pg_attribute) GETSTRUCT(attTuple))->attnum;
+	attnum = (GETSTRUCT(pg_attribute, attTuple))->attnum;
 	ReleaseSysCache(attTuple);
 
 	/*
@@ -7200,7 +7200,7 @@ ATExecDropNotNull(Relation rel, const char *colName, LOCKMODE lockmode)
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
-	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+	attTup = GETSTRUCT(pg_attribute, tuple);
 	attnum = attTup->attnum;
 
 	/* Prevent them from altering a system attribute */
@@ -7236,7 +7236,7 @@ ATExecDropNotNull(Relation rel, const char *colName, LOCKMODE lockmode)
 		indexTuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexoid));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", indexoid);
-		indexStruct = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexStruct = GETSTRUCT(pg_index, indexTuple);
 
 		/*
 		 * If the index is not a primary key or an index used as replica
@@ -7357,7 +7357,7 @@ ATPrepSetNotNull(List **wqueue, Relation rel,
 					 errmsg("column \"%s\" of relation \"%s\" does not exist",
 							cmd->name, RelationGetRelationName(rel))));
 
-		attnotnull = ((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull;
+		attnotnull = (GETSTRUCT(pg_attribute, tuple))->attnotnull;
 		ReleaseSysCache(tuple);
 		if (attnotnull)
 			return;
@@ -7407,7 +7407,7 @@ ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 
-	attnum = ((Form_pg_attribute) GETSTRUCT(tuple))->attnum;
+	attnum = (GETSTRUCT(pg_attribute, tuple))->attnum;
 
 	/* Prevent them from altering a system attribute */
 	if (attnum <= 0)
@@ -7419,9 +7419,9 @@ ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
 	/*
 	 * Okay, actually perform the catalog change ... if needed
 	 */
-	if (!((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull)
+	if (!(GETSTRUCT(pg_attribute, tuple))->attnotnull)
 	{
-		((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull = true;
+		(GETSTRUCT(pg_attribute, tuple))->attnotnull = true;
 
 		CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple);
 
@@ -7432,7 +7432,7 @@ ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
 		 * already found that we must verify some other NOT NULL constraint.
 		 */
 		if (!tab->verify_new_notnull &&
-			!NotNullImpliedByRelConstraints(rel, (Form_pg_attribute) GETSTRUCT(tuple)))
+			!NotNullImpliedByRelConstraints(rel, GETSTRUCT(pg_attribute, tuple)))
 		{
 			/* Tell Phase 3 it needs to test the constraint */
 			tab->verify_new_notnull = true;
@@ -7481,7 +7481,7 @@ ATExecCheckNotNull(AlteredTableInfo *tab, Relation rel,
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 
-	if (!((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull)
+	if (!(GETSTRUCT(pg_attribute, tuple))->attnotnull)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
 				 errmsg("constraint must be added to child tables too"),
@@ -7662,7 +7662,7 @@ ATExecAddIdentity(Relation rel, const char *colName,
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
-	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+	attTup = GETSTRUCT(pg_attribute, tuple);
 	attnum = attTup->attnum;
 
 	/* Can't alter a system attribute */
@@ -7757,7 +7757,7 @@ ATExecSetIdentity(Relation rel, const char *colName, Node *def, LOCKMODE lockmod
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 
-	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+	attTup = GETSTRUCT(pg_attribute, tuple);
 	attnum = attTup->attnum;
 
 	if (attnum <= 0)
@@ -7816,7 +7816,7 @@ ATExecDropIdentity(Relation rel, const char *colName, bool missing_ok, LOCKMODE
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 
-	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+	attTup = GETSTRUCT(pg_attribute, tuple);
 	attnum = attTup->attnum;
 
 	if (attnum <= 0)
@@ -7905,7 +7905,7 @@ ATPrepDropExpression(Relation rel, AlterTableCmd *cmd, bool recurse, bool recurs
 					 errmsg("column \"%s\" of relation \"%s\" does not exist",
 							cmd->name, RelationGetRelationName(rel))));
 
-		attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+		attTup = GETSTRUCT(pg_attribute, tuple);
 
 		if (attTup->attinhcount > 0)
 			ereport(ERROR,
@@ -7935,7 +7935,7 @@ ATExecDropExpression(Relation rel, const char *colName, bool missing_ok, LOCKMOD
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 
-	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+	attTup = GETSTRUCT(pg_attribute, tuple);
 	attnum = attTup->attnum;
 
 	if (attnum <= 0)
@@ -8074,7 +8074,7 @@ ATExecSetStatistics(Relation rel, const char *colName, int16 colNum, Node *newVa
 							colNum, RelationGetRelationName(rel))));
 	}
 
-	attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
+	attrtuple = GETSTRUCT(pg_attribute, tuple);
 
 	attnum = attrtuple->attnum;
 	if (attnum <= 0)
@@ -8144,7 +8144,7 @@ ATExecSetOptions(Relation rel, const char *colName, Node *options,
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
-	attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
+	attrtuple = GETSTRUCT(pg_attribute, tuple);
 
 	attnum = attrtuple->attnum;
 	if (attnum <= 0)
@@ -8234,7 +8234,7 @@ SetIndexStorageProperties(Relation rel, Relation attrelation,
 
 		if (HeapTupleIsValid(tuple))
 		{
-			Form_pg_attribute attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
+			Form_pg_attribute attrtuple = GETSTRUCT(pg_attribute, tuple);
 
 			if (setstorage)
 				attrtuple->attstorage = newstorage;
@@ -8300,7 +8300,7 @@ ATExecSetStorage(Relation rel, const char *colName, Node *newValue, LOCKMODE loc
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
-	attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
+	attrtuple = GETSTRUCT(pg_attribute, tuple);
 
 	attnum = attrtuple->attnum;
 	if (attnum <= 0)
@@ -8427,7 +8427,7 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 			return InvalidObjectAddress;
 		}
 	}
-	targetatt = (Form_pg_attribute) GETSTRUCT(tuple);
+	targetatt = GETSTRUCT(pg_attribute, tuple);
 
 	attnum = targetatt->attnum;
 
@@ -8501,7 +8501,7 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 			if (!HeapTupleIsValid(tuple))	/* shouldn't happen */
 				elog(ERROR, "cache lookup failed for attribute \"%s\" of relation %u",
 					 colName, childrelid);
-			childatt = (Form_pg_attribute) GETSTRUCT(tuple);
+			childatt = GETSTRUCT(pg_attribute, tuple);
 
 			if (childatt->attinhcount <= 0) /* shouldn't happen */
 				elog(ERROR, "relation %u has non-inherited attribute \"%s\"",
@@ -9230,7 +9230,7 @@ ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *tab, Relation rel,
 		cla_ht = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclasses[i]));
 		if (!HeapTupleIsValid(cla_ht))
 			elog(ERROR, "cache lookup failed for opclass %u", opclasses[i]);
-		cla_tup = (Form_pg_opclass) GETSTRUCT(cla_ht);
+		cla_tup = GETSTRUCT(pg_opclass, cla_ht);
 		amid = cla_tup->opcmethod;
 		opfamily = cla_tup->opcfamily;
 		opcintype = cla_tup->opcintype;
@@ -10008,7 +10008,7 @@ CloneFkReferenced(Relation parentRel, Relation partitionRel)
 							  NULL, 2, key);
 	while ((tuple = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_constraint constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		Form_pg_constraint constrForm = GETSTRUCT(pg_constraint, tuple);
 
 		clone = lappend_oid(clone, constrForm->oid);
 	}
@@ -10048,7 +10048,7 @@ CloneFkReferenced(Relation parentRel, Relation partitionRel)
 		tuple = SearchSysCache1(CONSTROID, constrOid);
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for constraint %u", constrOid);
-		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		constrForm = GETSTRUCT(pg_constraint, tuple);
 
 		/*
 		 * As explained above: don't try to clone a constraint for which we're
@@ -10235,7 +10235,7 @@ CloneFkReferencing(List **wqueue, Relation parentRel, Relation partRel)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for constraint %u",
 				 parentConstrOid);
-		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		constrForm = GETSTRUCT(pg_constraint, tuple);
 
 		/* Don't clone constraints whose parents are being cloned */
 		if (list_member_oid(clone, constrForm->conparentid))
@@ -10442,7 +10442,7 @@ tryAttachPartitionForeignKey(ForeignKeyCacheInfo *fk,
 									  ObjectIdGetDatum(parentConstrOid));
 	if (!HeapTupleIsValid(parentConstrTup))
 		elog(ERROR, "cache lookup failed for constraint %u", parentConstrOid);
-	parentConstr = (Form_pg_constraint) GETSTRUCT(parentConstrTup);
+	parentConstr = GETSTRUCT(pg_constraint, parentConstrTup);
 
 	/*
 	 * Do some quick & easy initial checks.  If any of these fail, we cannot
@@ -10473,7 +10473,7 @@ tryAttachPartitionForeignKey(ForeignKeyCacheInfo *fk,
 								 ObjectIdGetDatum(fk->conoid));
 	if (!HeapTupleIsValid(partcontup))
 		elog(ERROR, "cache lookup failed for constraint %u", fk->conoid);
-	partConstr = (Form_pg_constraint) GETSTRUCT(partcontup);
+	partConstr = GETSTRUCT(pg_constraint, partcontup);
 	if (OidIsValid(partConstr->conparentid) ||
 		!partConstr->convalidated ||
 		partConstr->condeferrable != parentConstr->condeferrable ||
@@ -10505,7 +10505,7 @@ tryAttachPartitionForeignKey(ForeignKeyCacheInfo *fk,
 							  NULL, 1, &key);
 	while ((trigtup = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_trigger trgform = (Form_pg_trigger) GETSTRUCT(trigtup);
+		Form_pg_trigger trgform = GETSTRUCT(pg_trigger, trigtup);
 		ObjectAddress trigger;
 
 		if (trgform->tgconstrrelid != fk->conrelid)
@@ -10579,7 +10579,7 @@ GetForeignKeyActionTriggers(Relation trigrel,
 							  NULL, 1, &key);
 	while ((trigtup = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_trigger trgform = (Form_pg_trigger) GETSTRUCT(trigtup);
+		Form_pg_trigger trgform = GETSTRUCT(pg_trigger, trigtup);
 
 		if (trgform->tgconstrrelid != conrelid)
 			continue;
@@ -10634,7 +10634,7 @@ GetForeignKeyCheckTriggers(Relation trigrel,
 							  NULL, 1, &key);
 	while ((trigtup = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_trigger trgform = (Form_pg_trigger) GETSTRUCT(trigtup);
+		Form_pg_trigger trgform = GETSTRUCT(pg_trigger, trigtup);
 
 		if (trgform->tgconstrrelid != confrelid)
 			continue;
@@ -10719,7 +10719,7 @@ ATExecAlterConstraint(Relation rel, AlterTableCmd *cmd, bool recurse,
 				 errmsg("constraint \"%s\" of relation \"%s\" does not exist",
 						cmdcon->conname, RelationGetRelationName(rel))));
 
-	currcon = (Form_pg_constraint) GETSTRUCT(contuple);
+	currcon = GETSTRUCT(pg_constraint, contuple);
 	if (currcon->contype != CONSTRAINT_FOREIGN)
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
@@ -10745,7 +10745,7 @@ ATExecAlterConstraint(Relation rel, AlterTableCmd *cmd, bool recurse,
 		/* Loop to find the topmost constraint */
 		while (HeapTupleIsValid(tp = SearchSysCache1(CONSTROID, ObjectIdGetDatum(parent))))
 		{
-			Form_pg_constraint contup = (Form_pg_constraint) GETSTRUCT(tp);
+			Form_pg_constraint contup = GETSTRUCT(pg_constraint, tp);
 
 			/* If no parent, this is the constraint we want */
 			if (!OidIsValid(contup->conparentid))
@@ -10821,7 +10821,7 @@ ATExecAlterConstrRecurse(Constraint *cmdcon, Relation conrel, Relation tgrel,
 	Oid			refrelid;
 	bool		changed = false;
 
-	currcon = (Form_pg_constraint) GETSTRUCT(contuple);
+	currcon = GETSTRUCT(pg_constraint, contuple);
 	conoid = currcon->oid;
 	refrelid = currcon->confrelid;
 
@@ -10841,7 +10841,7 @@ ATExecAlterConstrRecurse(Constraint *cmdcon, Relation conrel, Relation tgrel,
 		SysScanDesc tgscan;
 
 		copyTuple = heap_copytuple(contuple);
-		copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
+		copy_con = GETSTRUCT(pg_constraint, copyTuple);
 		copy_con->condeferrable = cmdcon->deferrable;
 		copy_con->condeferred = cmdcon->initdeferred;
 		CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
@@ -10867,7 +10867,7 @@ ATExecAlterConstrRecurse(Constraint *cmdcon, Relation conrel, Relation tgrel,
 									NULL, 1, &tgkey);
 		while (HeapTupleIsValid(tgtuple = systable_getnext(tgscan)))
 		{
-			Form_pg_trigger tgform = (Form_pg_trigger) GETSTRUCT(tgtuple);
+			Form_pg_trigger tgform = GETSTRUCT(pg_trigger, tgtuple);
 			Form_pg_trigger copy_tg;
 			HeapTuple	copyTuple;
 
@@ -10894,7 +10894,7 @@ ATExecAlterConstrRecurse(Constraint *cmdcon, Relation conrel, Relation tgrel,
 				continue;
 
 			copyTuple = heap_copytuple(tgtuple);
-			copy_tg = (Form_pg_trigger) GETSTRUCT(copyTuple);
+			copy_tg = GETSTRUCT(pg_trigger, copyTuple);
 
 			copy_tg->tgdeferrable = cmdcon->deferrable;
 			copy_tg->tginitdeferred = cmdcon->initdeferred;
@@ -10933,7 +10933,7 @@ ATExecAlterConstrRecurse(Constraint *cmdcon, Relation conrel, Relation tgrel,
 
 		while (HeapTupleIsValid(childtup = systable_getnext(pscan)))
 		{
-			Form_pg_constraint childcon = (Form_pg_constraint) GETSTRUCT(childtup);
+			Form_pg_constraint childcon = GETSTRUCT(pg_constraint, childtup);
 			Relation	childrel;
 
 			childrel = table_open(childcon->conrelid, lockmode);
@@ -10997,7 +10997,7 @@ ATExecValidateConstraint(List **wqueue, Relation rel, char *constrName,
 				 errmsg("constraint \"%s\" of relation \"%s\" does not exist",
 						constrName, RelationGetRelationName(rel))));
 
-	con = (Form_pg_constraint) GETSTRUCT(tuple);
+	con = GETSTRUCT(pg_constraint, tuple);
 	if (con->contype != CONSTRAINT_FOREIGN &&
 		con->contype != CONSTRAINT_CHECK)
 		ereport(ERROR,
@@ -11121,7 +11121,7 @@ ATExecValidateConstraint(List **wqueue, Relation rel, char *constrName,
 		 * Now update the catalog, while we have the door open.
 		 */
 		copyTuple = heap_copytuple(tuple);
-		copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
+		copy_con = GETSTRUCT(pg_constraint, copyTuple);
 		copy_con->convalidated = true;
 		CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
 
@@ -11171,9 +11171,9 @@ transformColumnNameList(Oid relId, List *colList,
 					(errcode(ERRCODE_TOO_MANY_COLUMNS),
 					 errmsg("cannot have more than %d keys in a foreign key",
 							INDEX_MAX_KEYS)));
-		attnums[attnum] = ((Form_pg_attribute) GETSTRUCT(atttuple))->attnum;
+		attnums[attnum] = (GETSTRUCT(pg_attribute, atttuple))->attnum;
 		if (atttypids != NULL)
-			atttypids[attnum] = ((Form_pg_attribute) GETSTRUCT(atttuple))->atttypid;
+			atttypids[attnum] = (GETSTRUCT(pg_attribute, atttuple))->atttypid;
 		ReleaseSysCache(atttuple);
 		attnum++;
 	}
@@ -11224,7 +11224,7 @@ transformFkeyGetPrimaryKey(Relation pkrel, Oid *indexOid,
 		indexTuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexoid));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", indexoid);
-		indexStruct = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexStruct = GETSTRUCT(pg_index, indexTuple);
 		if (indexStruct->indisprimary && indexStruct->indisvalid)
 		{
 			/*
@@ -11337,7 +11337,7 @@ transformFkeyCheckAttrs(Relation pkrel,
 		indexTuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexoid));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", indexoid);
-		indexStruct = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexStruct = GETSTRUCT(pg_index, indexTuple);
 
 		/*
 		 * Must have the right number of columns; must be unique and not a
@@ -11851,7 +11851,7 @@ ATExecDropConstraint(Relation rel, const char *constrName,
 	{
 		ObjectAddress conobj;
 
-		con = (Form_pg_constraint) GETSTRUCT(tuple);
+		con = GETSTRUCT(pg_constraint, tuple);
 
 		/* Don't drop inherited constraints */
 		if (con->coninhcount > 0 && !recursing)
@@ -11984,7 +11984,7 @@ ATExecDropConstraint(Relation rel, const char *constrName,
 
 		systable_endscan(scan);
 
-		con = (Form_pg_constraint) GETSTRUCT(copy_tuple);
+		con = GETSTRUCT(pg_constraint, copy_tuple);
 
 		/* Right now only CHECK constraints can be inherited */
 		if (con->contype != CONSTRAINT_CHECK)
@@ -12092,7 +12092,7 @@ ATPrepAlterColumnType(List **wqueue,
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
-	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
+	attTup = GETSTRUCT(pg_attribute, tuple);
 	attnum = attTup->attnum;
 
 	/* Can't alter a system attribute */
@@ -12273,7 +12273,7 @@ ATPrepAlterColumnType(List **wqueue,
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 						 errmsg("column \"%s\" of relation \"%s\" does not exist",
 								colName, RelationGetRelationName(childrel))));
-			childattTup = (Form_pg_attribute) GETSTRUCT(childtuple);
+			childattTup = GETSTRUCT(pg_attribute, childtuple);
 
 			if (childattTup->attinhcount > numparents)
 				ereport(ERROR,
@@ -12433,7 +12433,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 				(errcode(ERRCODE_UNDEFINED_COLUMN),
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
-	attTup = (Form_pg_attribute) GETSTRUCT(heapTup);
+	attTup = GETSTRUCT(pg_attribute, heapTup);
 	attnum = attTup->attnum;
 	attOldTup = TupleDescAttr(tab->oldDesc, attnum - 1);
 
@@ -12447,7 +12447,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 
 	/* Look up the target type (should not fail, since prep found it) */
 	typeTuple = typenameType(NULL, typeName, &targettypmod);
-	tform = (Form_pg_type) GETSTRUCT(typeTuple);
+	tform = GETSTRUCT(pg_type, typeTuple);
 	targettype = tform->oid;
 	/* And the collation */
 	targetcollid = GetColumnDefCollation(NULL, def, targettype);
@@ -12521,7 +12521,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 
 	while (HeapTupleIsValid(depTup = systable_getnext(scan)))
 	{
-		Form_pg_depend foundDep = (Form_pg_depend) GETSTRUCT(depTup);
+		Form_pg_depend foundDep = GETSTRUCT(pg_depend, depTup);
 		ObjectAddress foundObject;
 
 		foundObject.classId = foundDep->classid;
@@ -12727,7 +12727,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 
 	while (HeapTupleIsValid(depTup = systable_getnext(scan)))
 	{
-		Form_pg_depend foundDep = (Form_pg_depend) GETSTRUCT(depTup);
+		Form_pg_depend foundDep = GETSTRUCT(pg_depend, depTup);
 		ObjectAddress foundObject;
 
 		foundObject.classId = foundDep->refclassid;
@@ -12815,7 +12815,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 									   valuesAtt, nullsAtt, replacesAtt);
 			heap_freetuple(heapTup);
 			heapTup = newTup;
-			attTup = (Form_pg_attribute) GETSTRUCT(heapTup);
+			attTup = GETSTRUCT(pg_attribute, heapTup);
 		}
 	}
 
@@ -13093,7 +13093,7 @@ ATPostAlterTypeCleanup(List **wqueue, AlteredTableInfo *tab, LOCKMODE lockmode)
 		tup = SearchSysCache1(CONSTROID, ObjectIdGetDatum(oldId));
 		if (!HeapTupleIsValid(tup)) /* should not happen */
 			elog(ERROR, "cache lookup failed for constraint %u", oldId);
-		con = (Form_pg_constraint) GETSTRUCT(tup);
+		con = GETSTRUCT(pg_constraint, tup);
 		if (OidIsValid(con->conrelid))
 			relid = con->conrelid;
 		else
@@ -13583,7 +13583,7 @@ ATExecAlterColumnGenericOptions(Relation rel,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("foreign table \"%s\" does not exist",
 						RelationGetRelationName(rel))));
-	fttableform = (Form_pg_foreign_table) GETSTRUCT(tuple);
+	fttableform = GETSTRUCT(pg_foreign_table, tuple);
 	server = GetForeignServer(fttableform->ftserver);
 	fdw = GetForeignDataWrapper(server->fdwid);
 
@@ -13599,7 +13599,7 @@ ATExecAlterColumnGenericOptions(Relation rel,
 						colName, RelationGetRelationName(rel))));
 
 	/* Prevent them from altering a system attribute */
-	atttableform = (Form_pg_attribute) GETSTRUCT(tuple);
+	atttableform = GETSTRUCT(pg_attribute, tuple);
 	attnum = atttableform->attnum;
 	if (attnum <= 0)
 		ereport(ERROR,
@@ -13687,7 +13687,7 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relationOid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relationOid);
-	tuple_class = (Form_pg_class) GETSTRUCT(tuple);
+	tuple_class = GETSTRUCT(pg_class, tuple);
 
 	/* Can we change the ownership of this tuple? */
 	switch (tuple_class->relkind)
@@ -13923,7 +13923,7 @@ change_owner_fix_column_acls(Oid relationOid, Oid oldOwnerId, Oid newOwnerId)
 							  true, NULL, 1, key);
 	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
 	{
-		Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(attributeTuple);
+		Form_pg_attribute att = GETSTRUCT(pg_attribute, attributeTuple);
 		Datum		repl_val[Natts_pg_attribute];
 		bool		repl_null[Natts_pg_attribute];
 		bool		repl_repl[Natts_pg_attribute];
@@ -14000,7 +14000,7 @@ change_owner_recurse_to_sequences(Oid relationOid, Oid newOwnerId, LOCKMODE lock
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend depForm = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depForm = GETSTRUCT(pg_depend, tup);
 		Relation	seqRel;
 
 		/* skip dependencies other than auto dependencies on columns */
@@ -14543,7 +14543,7 @@ AlterTableMoveAll(AlterTableMoveAllStmt *stmt)
 	scan = table_beginscan_catalog(rel, 1, key);
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class relForm = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class relForm = GETSTRUCT(pg_class, tuple);
 		Oid			relOid = relForm->oid;
 
 		/*
@@ -14881,7 +14881,7 @@ CreateInheritance(Relation child_rel, Relation parent_rel)
 	inhseqno = 0;
 	while (HeapTupleIsValid(inheritsTuple = systable_getnext(scan)))
 	{
-		Form_pg_inherits inh = (Form_pg_inherits) GETSTRUCT(inheritsTuple);
+		Form_pg_inherits inh = GETSTRUCT(pg_inherits, inheritsTuple);
 
 		if (inh->inhparent == RelationGetRelid(parent_rel))
 			ereport(ERROR,
@@ -14926,7 +14926,7 @@ decompile_conbin(HeapTuple contup, TupleDesc tupdesc)
 	Datum		attr;
 	Datum		expr;
 
-	con = (Form_pg_constraint) GETSTRUCT(contup);
+	con = GETSTRUCT(pg_constraint, contup);
 	attr = heap_getattr(contup, Anum_pg_constraint_conbin, tupdesc, &isnull);
 	if (isnull)
 		elog(ERROR, "null conbin for constraint %u", con->oid);
@@ -14946,8 +14946,8 @@ decompile_conbin(HeapTuple contup, TupleDesc tupdesc)
 static bool
 constraints_equivalent(HeapTuple a, HeapTuple b, TupleDesc tupleDesc)
 {
-	Form_pg_constraint acon = (Form_pg_constraint) GETSTRUCT(a);
-	Form_pg_constraint bcon = (Form_pg_constraint) GETSTRUCT(b);
+	Form_pg_constraint acon = GETSTRUCT(pg_constraint, a);
+	Form_pg_constraint bcon = GETSTRUCT(pg_constraint, b);
 
 	if (acon->condeferrable != bcon->condeferrable ||
 		acon->condeferred != bcon->condeferred ||
@@ -15007,7 +15007,7 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 		if (HeapTupleIsValid(tuple))
 		{
 			/* Check they are same type, typmod, and collation */
-			Form_pg_attribute childatt = (Form_pg_attribute) GETSTRUCT(tuple);
+			Form_pg_attribute childatt = GETSTRUCT(pg_attribute, tuple);
 
 			if (attribute->atttypid != childatt->atttypid ||
 				attribute->atttypmod != childatt->atttypmod)
@@ -15170,7 +15170,7 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 
 	while (HeapTupleIsValid(parent_tuple = systable_getnext(parent_scan)))
 	{
-		Form_pg_constraint parent_con = (Form_pg_constraint) GETSTRUCT(parent_tuple);
+		Form_pg_constraint parent_con = GETSTRUCT(pg_constraint, parent_tuple);
 		SysScanDesc child_scan;
 		ScanKeyData child_key;
 		HeapTuple	child_tuple;
@@ -15193,7 +15193,7 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 
 		while (HeapTupleIsValid(child_tuple = systable_getnext(child_scan)))
 		{
-			Form_pg_constraint child_con = (Form_pg_constraint) GETSTRUCT(child_tuple);
+			Form_pg_constraint child_con = GETSTRUCT(pg_constraint, child_tuple);
 			HeapTuple	child_copy;
 
 			if (child_con->contype != CONSTRAINT_CHECK)
@@ -15234,7 +15234,7 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 			 * later on, this change will just roll back.)
 			 */
 			child_copy = heap_copytuple(child_tuple);
-			child_con = (Form_pg_constraint) GETSTRUCT(child_copy);
+			child_con = GETSTRUCT(pg_constraint, child_copy);
 			child_con->coninhcount++;
 
 			/*
@@ -15342,7 +15342,7 @@ MarkInheritDetached(Relation child_rel, Relation parent_rel)
 	{
 		Form_pg_inherits inhForm;
 
-		inhForm = (Form_pg_inherits) GETSTRUCT(inheritsTuple);
+		inhForm = GETSTRUCT(pg_inherits, inheritsTuple);
 		if (inhForm->inhdetachpending)
 			ereport(ERROR,
 					errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
@@ -15357,7 +15357,7 @@ MarkInheritDetached(Relation child_rel, Relation parent_rel)
 			HeapTuple	newtup;
 
 			newtup = heap_copytuple(inheritsTuple);
-			((Form_pg_inherits) GETSTRUCT(newtup))->inhdetachpending = true;
+			(GETSTRUCT(pg_inherits, newtup))->inhdetachpending = true;
 
 			CatalogTupleUpdate(catalogRelation,
 							   &inheritsTuple->t_self,
